package com.company.bpmdemo.web.screens.contract;

import com.company.bpmdemo.UiNotificationEvent;
import com.haulmont.bpm.gui.procactionsfragment.ProcActionsFragment;
import com.haulmont.cuba.core.global.Messages;
import com.haulmont.cuba.gui.Notifications;
import com.haulmont.cuba.gui.components.GroupTable;
import com.haulmont.cuba.gui.model.CollectionLoader;
import com.haulmont.cuba.gui.model.InstanceContainer;
import com.haulmont.cuba.gui.screen.*;
import com.company.bpmdemo.entity.Contract;
import org.springframework.context.event.EventListener;

import javax.inject.Inject;


@UiController("bpmdemo_Contract.browse")
@UiDescriptor("contract-browse.xml")
@LookupComponent("contractsTable")
@LoadDataBeforeShow
public class ContractBrowse extends StandardLookup<Contract> {
    private static final String PROCESS_CODE = "delete";


    @Inject
    protected ProcActionsFragment procActionsFragment;
    @Inject
    private GroupTable<Contract> contractsTable;
    @Inject
    private Notifications notifications;
    @Inject
    private Messages messages;
    @Inject
    private CollectionLoader<Contract> contractsDl;


    @EventListener
    public void onUiNotificationEvent(UiNotificationEvent event) {
        contractsDl.load();
        notifications.create().withCaption(messages.getMessage("com.company.bpmdemo.web", "update")).show();

    }

// инициализация процесса по кнопке
//    public void requestToDelete() {
//
//        if (contractsTable.getSingleSelected() == null) {
//            notifications.create().withCaption(messages.getMessage("com.company.bpmdemo.web", "CheckObj")).show();
//        } else {
//            procActionsFragment.initializer()
//                    .standard()
//                    .init(PROCESS_CODE, contractsTable.getSingleSelected());
//            contractsDl.load();
//
//        }
//    }


    @Subscribe(id = "contractsDc", target = Target.DATA_CONTAINER)
    private void onCustomerDcItemChange(InstanceContainer.ItemChangeEvent<Contract> event) {

        if (contractsTable.getSingleSelected() != null){
            procActionsFragment.initializer()
                    .standard()
                    .init(PROCESS_CODE, contractsTable.getSingleSelected());
        }

    }


}